"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
exports.__esModule = true;
var react_1 = __importStar(require("react"));
var hooks_1 = require("@steroidsjs/core/hooks");
require("./AvatarView.scss");
function Avatar(props) {
    var _a;
    var bem = hooks_1.useBem('AvatarView');
    var _b = react_1.useState(true), isImgExist = _b[0], setIsImgExist = _b[1];
    var customSize = typeof props.size === 'number'
        ? {
            width: props.size,
            height: props.size,
            lineHeight: props.size + "px",
            fontSize: props.size / 3
        }
        : {};
    var hasImageElement = react_1.isValidElement(props.src);
    var renderingChildren;
    if (typeof props.src === 'string' && isImgExist) {
        renderingChildren = (react_1["default"].createElement("img", { src: props.src, srcSet: props.srcSet, alt: props.alt }));
    }
    else if (hasImageElement) {
        renderingChildren = props.src;
    }
    else if (props.children) {
        renderingChildren = (react_1["default"].createElement("span", null, props.children));
    }
    else if (typeof props.alt === 'string') {
        renderingChildren = (react_1["default"].createElement("span", null, props.alt));
    }
    else if (props.src && props.children === "") {
        renderingChildren = (react_1["default"].createElement("img", { src: "https://hh.ru/employer-logo/3775460.png", srcSet: props.srcSet }));
    }
    return (react_1["default"].createElement("span", { className: bem.block((_a = {},
            _a["large"] = props.size === 'large',
            _a["medium"] = props.size === 'medium',
            _a["small"] = props.size === 'small',
            _a["square"] = props.shape === 'square',
            _a["circle"] = props.shape === 'circle',
            _a)), style: __assign({}, customSize) }, renderingChildren));
}
exports["default"] = Avatar;
