"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var React = __importStar(require("react"));
var isString_1 = __importDefault(require("lodash-es/isString"));
var Icon_1 = __importDefault(require("@steroidsjs/core/ui/icon/Icon"));
var hooks_1 = require("@steroidsjs/core/hooks");
function ButtonView(props) {
    var bem = hooks_1.useBem('ButtonView');
    var renderLabel = function () {
        var title = props.label && isString_1["default"](props.label)
            ? props.label
            : (props.hint || null);
        return (React.createElement(React.Fragment, null,
            props.isLoading && (React.createElement("div", { className: bem.element('preloader') },
                React.createElement("span", { className: 'spinner-border spinner-border-sm', role: 'status', "aria-hidden": 'true' }))),
            (props.showLabelOnLoading || !props.isLoading) && (React.createElement("span", { className: bem.element('label') },
                props.icon && (React.createElement(Icon_1["default"], { name: props.icon, title: title, className: bem.element('icon', !props.label && 'without-label') })),
                props.children))));
    };
    var renderBadge = function () {
        if (!props.badge.enable) {
            return null;
        }
        return (React.createElement("span", { className: bem('badge', props.badge.color && "badge-" + props.badge.color, bem.element('badge'), props.badge.className) }, props.badge.value));
    };
    var className = bem(bem.block({
        color: props.color,
        outline: props.outline,
        size: props.size,
        disabled: props.disabled,
        submitting: props.submitting,
        loading: props.isLoading,
        failed: props.isFailed,
        link: props.tag === 'a'
    }), !props.link && 'btn', props.size && "btn-" + props.size, !props.link && "btn-" + (props.outline ? 'outline-' : '') + props.color, props.block && 'btn-block', props.link && 'btn-link', props.className);
    if (props.tag === 'a') {
        return (React.createElement("a", { className: className, href: props.url, onClick: props.onClick, style: props.style, target: props.target },
            renderLabel(),
            renderBadge()));
    }
    return (React.createElement("button", { type: props.type, disabled: props.disabled, onClick: props.onClick, style: props.style, className: className },
        renderLabel(),
        renderBadge()));
}
exports["default"] = ButtonView;
