"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var React = __importStar(require("react"));
var react_day_picker_1 = __importDefault(require("react-day-picker"));
var isString_1 = __importDefault(require("lodash-es/isString"));
var upperFirst_1 = __importDefault(require("lodash-es/upperFirst"));
var Icon_1 = __importDefault(require("@steroidsjs/core/ui/icon/Icon"));
var DropDownField_1 = __importDefault(require("@steroidsjs/core/ui/form/DropDownField"));
var hooks_1 = require("@steroidsjs/core/hooks");
var react_1 = require("react");
var DropDown_1 = __importDefault(require("@steroidsjs/core/ui/content/DropDown"));
require("./DateFieldView.scss");
function YearMonthForm(props) {
    var localeUtils = props.localeUtils, locale = props.locale, fromYear = props.fromYear, toYear = props.toYear, classNames = props.classNames, customClassNames = props.customClassNames, date = props.date;
    var currentMonth = date.getMonth();
    var currentYear = date.getFullYear();
    var handleYearChange = function (newYear) {
        if (newYear !== currentYear) {
            props.onChange(new Date(newYear, currentMonth));
        }
    };
    var handleMonthChange = function (newMonth) {
        if (newMonth !== currentMonth) {
            console.log('handleMonthChange', newMonth);
            props.onChange(new Date(currentYear, newMonth));
        }
    };
    var months = react_1.useMemo(function () { return (localeUtils.getMonths(locale).map(function (item, index) { return ({
        id: index,
        label: upperFirst_1["default"](item)
    }); })); }, [localeUtils, locale]);
    var years = react_1.useMemo(function () {
        var result = [];
        for (var i = fromYear.getFullYear(); i <= toYear.getFullYear(); i += 1) {
            result.push(i);
        }
        return result;
    }, [fromYear, toYear]);
    return (React.createElement("div", { className: classNames.caption },
        React.createElement("div", { className: customClassNames.caption },
            React.createElement("div", { className: customClassNames.monthSelect },
                React.createElement(DropDownField_1["default"], { attribute: 'month', size: 'md', layout: false, noBorder: true, items: months, onChange: function (month) { return handleMonthChange(month); }, selectedIds: [currentMonth] })),
            React.createElement("div", { className: customClassNames.yearSelect },
                React.createElement(DropDownField_1["default"], { attribute: 'year', size: 'md', layout: false, className: customClassNames.monthSelect, noBorder: true, items: years, onChange: function (year) { return handleYearChange(year); }, selectedIds: [currentYear] })))));
}
function DateFieldView(props) {
    var bem = hooks_1.useBem('DateFieldView');
    var captionElement = react_1.useCallback(function (_a) {
        var classNames = _a.classNames, date = _a.date, localeUtils = _a.localeUtils, locale = _a.locale;
        return (React.createElement(YearMonthForm, { date: date, localeUtils: localeUtils, locale: locale, classNames: classNames, customClassNames: {
                caption: bem.element('caption'),
                yearSelect: bem.element('caption-year'),
                monthSelect: bem.element('caption-month')
            }, onChange: props.updateMonth, fromYear: props.fromYear, toYear: props.toYear }));
    }, []);
    return (React.createElement(DropDown_1["default"], { content: function () {
            return React.createElement(react_day_picker_1["default"], { captionElement: captionElement, selectedDays: props.dateFrom, onDayClick: props.onDayClick, month: props.month });
        }, position: 'bottomLeft', visible: props.isPanelOpen, toggleVisibility: function (value) { return value ? props.closePanel() : props.openPanel(); } },
        React.createElement("div", { className: bem(bem.block({
                size: props.size,
                'has-icon': !!props.icon,
                'is-invalid': !!props.isInvalid
            }), props.className), style: props.style },
            React.createElement("div", { className: bem.element('body') },
                React.createElement("input", __assign({}, props.inputProps, { className: bem(bem.element('input', {
                        size: props.size
                    }), props.isInvalid && 'is-invalid'), onChange: function (e) { return props.inputProps.onChange(e.target.value); }, onFocus: function (e) {
                        e.preventDefault();
                        props.openPanel();
                    }, onBlur: function (e) {
                        e.preventDefault();
                        props.onBlur();
                    } })),
                React.createElement("div", { className: bem.element('icon-container') },
                    props.icon && (React.createElement(Icon_1["default"], { className: bem.element('icon'), name: isString_1["default"](props.icon) ? props.icon : 'calendar-alt' })),
                    props.showRemove && props.input.value && (React.createElement(Icon_1["default"], { className: bem.element('icon', 'close'), onClick: function (e) {
                            e.preventDefault();
                            props.clearInput();
                        }, name: 'times-circle' })))))));
}
exports["default"] = DateFieldView;
