"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var React = __importStar(require("react"));
var hooks_1 = require("@steroidsjs/core/hooks");
var react_1 = require("react");
var padStart_1 = __importDefault(require("lodash-es/padStart"));
require("./TimePanelView.scss");
function TimePanelView(props) {
    var bem = hooks_1.useBem('TimePanelView');
    var hours = react_1.useMemo(function () {
        var result = [];
        for (var i = 0; i < 24; i++) {
            var hour = padStart_1["default"](i, 2, '0');
            result.push(hour);
        }
        return result;
    }, []);
    var minutes = react_1.useMemo(function () {
        var result = [];
        for (var i = 0; i < 60; i++) {
            var minute = padStart_1["default"](i, 2, '0');
            result.push(minute);
        }
        return result;
    }, []);
    return (React.createElement("div", { className: bem.block() },
        React.createElement("div", { className: bem.element('body') },
            React.createElement("ul", { className: bem.element('column') }, hours.map(function (value, index) {
                var _a;
                return (React.createElement("li", { key: index, className: bem.element('cell', {
                        'selected': value === (((_a = props.input.value) === null || _a === void 0 ? void 0 : _a.substring(0, 2)) || '00')
                    }), onClick: function (e) {
                        e.preventDefault();
                        props.changeHours(value);
                    } },
                    React.createElement("div", { className: bem.element('cell-value') }, value)));
            })),
            React.createElement("ul", { className: bem.element('column') }, minutes.map(function (value, index) {
                var _a;
                return (React.createElement("li", { key: index, className: bem.element('cell', {
                        'selected': value === (((_a = props.input.value) === null || _a === void 0 ? void 0 : _a.substring(3, 6)) || '00')
                    }), onClick: function (e) { return props.changeMinutes(value); } },
                    React.createElement("div", { className: bem.element('cell-value') }, value)));
            }))),
        React.createElement("div", { className: bem.element('footer') },
            React.createElement("button", { className: bem.element('button', 'now'), onClick: function (e) {
                    e.preventDefault();
                    props.setNow();
                } }, "Now"),
            React.createElement("button", { className: bem.element('button', 'ok') }, "Ok"))));
}
exports["default"] = TimePanelView;
